package io.lroyia.util;

/**
 * 自动以字符串工具类，继承于org.apache.commons.lang3.StringUtils
 * @author <a href="https://blog.lroyia.top">lroyia</a>
 * @since 2020/7/31 14:25
 **/
public abstract class StringUtils extends org.apache.commons.lang3.StringUtils {

    /**
     * ASCII表中可见字符从!开始，偏移位值为33(Decimal)
     */
    private static final char DBC_CHAR_START = 33; // 半角!

    /**
     * ASCII表中可见字符到~结束，偏移位值为126(Decimal)
     */
    private static final char DBC_CHAR_END = 126; // 半角~

    /**
     * 全角对应于ASCII表的可见字符从！开始，偏移值为65281
     */
    private static final char SBC_CHAR_START = 65281; // 全角！

    /**
     * 全角对应于ASCII表的可见字符到～结束，偏移值为65374
     */
    private static final char SBC_CHAR_END = 65374; // 全角～

    /**
     * ASCII表中除空格外的可见字符与对应的全角字符的相对偏移
     */
    private static final int CONVERT_STEP = 65248; // 全角半角转换间隔

    /**
     * 全角空格的值，它没有遵从与ASCII的相对偏移，必须单独处理
     */
    private static final char SBC_SPACE = 12288; // 全角空格 12288

    /**
     * 半角空格的值，在ASCII中为32(Decimal)
     */
    private static final char DBC_SPACE = ' '; // 半角空格

    /**
     * 将Object转为字符串（null时返回空字串）
     * @param obj obj
     * @return 字符串
     * @author lroyia
     * @since 2020年7月31日 14:28:22
     */
    public static String tranObject(Object obj){
        return obj == null ? EMPTY : obj.toString();
    }

    /**
     * 获取文件扩展名
     * @param fileName 文件全名
     * @return 文件扩展名
     * @author lroyia
     * @since 2020年9月23日 14:37:45
     */
    public static String getFileExt(String fileName){
        int pointIdx = fileName.lastIndexOf(".");
        if(pointIdx < 0) return EMPTY;
        return fileName.substring(pointIdx);
    }

    /**
     * 批量eq
     * @param source 源字符串
     * @param target    目标比较串
     * @return  比较结果
     * @author lroyia
     * @since  2021年5月24日 10:40:34
     */
    public static boolean inEq(String source, String... target){
        for (String s : target) {
            if(source.equals(s)){
                return true;
            }
        }
        return false;
    }

    /**
     * 批量比较存在
     * @param source 源字符串
     * @param target    目标比较串
     * @return  比较结果
     * @author lroyia
     * @since  2021年5月24日 10:40:34
     */
    public static boolean inContains(String source, String... target){
        for (String s : target) {
            if(source.equals(s)){
                return true;
            }
        }
        return false;
    }

    /**
     * <PRE>
     * 半角字符->全角字符转换
     * 只处理空格，!到˜之间的字符，忽略其他
     * </PRE>
     * <a href="https://www.cnblogs.com/jinzhiming/p/10762175.html">参考</a>
     */
    public static String halfAngle2Full(String src) {
        if (src == null) {
            return src;
        }
        StringBuilder buf = new StringBuilder(src.length()+1);
        char[] ca = src.toCharArray();
        for (int i = 0; i < ca.length; i++) {
            if (ca[i] == DBC_SPACE) { // 如果是半角空格，直接用全角空格替代
                buf.append(SBC_SPACE);
            } else if ((ca[i] >= DBC_CHAR_START) && (ca[i] <= DBC_CHAR_END)) { // 字符是!到~之间的可见字符
                buf.append((char) (ca[i] + CONVERT_STEP));
            } else { // 不对空格以及ascii表中其他可见字符之外的字符做任何处理
                buf.append(ca[i]);
            }
        }
        return buf.toString();
    }

    /**
     * <PRE>
     * 全角字符->半角字符转换
     * 只处理全角的空格，全角！到全角～之间的字符，忽略其他
     * </PRE>
     * <a href="https://www.cnblogs.com/jinzhiming/p/10762175.html">参考</a>
     */
    public static String fullAngle2Half(String src) {
        if (src == null) {
            return src;
        }
        StringBuilder buf = new StringBuilder(src.length()+1);
        char[] ca = src.toCharArray();
        for (int i = 0; i < src.length(); i++) {
            if (ca[i] >= SBC_CHAR_START && ca[i] <= SBC_CHAR_END) { // 如果位于全角！到全角～区间内
                buf.append((char) (ca[i] - CONVERT_STEP));
            } else if (ca[i] == SBC_SPACE) { // 如果是全角空格
                buf.append(DBC_SPACE);
            } else { // 不处理全角空格，全角！到全角～区间外的字符
                buf.append(ca[i]);
            }
        }
        return buf.toString();
    }

}
